#include <windows.h>
#include <stdio.h>
#include <bncs_string.h>
#include <bncs_config.h>
#include "TestLeitch.h"

#define PNL_MAIN	1

#define TIMER_SETUP	1

// Make our class visible to the outside world
EXPORT_BNCS_SCRIPT(TestLeitch)

// constructor - equivalent to ApplCore STARTUP
TestLeitch::TestLeitch( bncs_client_callback * parent, const char * path ) : bncs_script_helper( parent, path )
{
	sdi_counter = 0;
	audio_counter = 0;

	// show a panel from file p1.bncs_ui and we'll know it as our panel PNL_MAIN
	panelShow( PNL_MAIN, "p1.bncs_ui" );

	infoRegister(765, 1, 2);
}

// destructor - equivalent to ApplCore CLOSEDOWN
TestLeitch::~TestLeitch()
{
	infoUnregister(765);
}

// all button pushes and notifications come here
void TestLeitch::buttonCallback( buttonNotify *b )
{
	// Look for reset buttons
	if (b->panel() == PNL_MAIN){

		if (b->id() == "Reset1") {
			sdi_counter = 0;
			textPut("text", bncs_string(sdi_counter), PNL_MAIN, "sdi_count");
			return;
		}
		if (b->id() == "Reset2") {
			audio_counter = 0;
			textPut("text", bncs_string(audio_counter), PNL_MAIN, "audio_count");
			return;
		}
	}
}

// all revertives come here
int TestLeitch::revertiveCallback( revertiveNotify * r )
{
	switch(r->device())
	{
		case 765:
			switch (r->index()){
			case 1:
				sdi_counter++;
				textPut("text", bncs_string(sdi_counter), PNL_MAIN, "sdi_count");
				break;
			case 2:
				audio_counter++;
				textPut("text", bncs_string(audio_counter), PNL_MAIN, "audio_count");
				break;
			}
		break;
	}

	return 0;
}

// all database name changes come back here
void TestLeitch::databaseCallback( revertiveNotify * r )
{
}

// all parent notifications come here i.e. when this script is just one 
//  component of another dialog then our host might want to tell us things
bncs_string TestLeitch::parentCallback( parentNotify *p )
{
	if( p->command() == "return" )
	{
		if( p->value() == "all" )
		{	// Persisting values for bncs_vis_ed
			bncs_stringlist sl;
			
			sl << bncs_string( "myParam=%1" ).arg( m_myParam );
			
			return sl.toString( '\n' );
		}

		else if( p->value() == "myParam" )
		{	// Specific value being asked for by a textGet
			return( bncs_string( "%1=%2" ).arg( p->value() ).arg( m_myParam ) );
		}

	}
	else if( p->command() == "instance" && p->value() != m_instance )
	{	// Our instance is being set/changed
		m_instance = p->value();
		//Do something instance-change related here
	}

	else if( p->command() == "myParam" )
	{	// Persisted value or 'Command' being set here
		m_myParam = p->value();
	}

	// ***** CONNECTIONS EVENTS HELPER LIST *****
	else if( p->command() == "_events" )
	{	// Helper-list of everything in this component generated by hostNotify's
		bncs_stringlist sl;

		sl << "notify=*";		
		
		return sl.toString( '\n' );
	}

	// ***** CONNECTIONS COMMANDS HELPER LIST *****
	else if( p->command() == "_commands" )
	{	// Helper-list of any commands/parameters you might want to set at run-time
		bncs_stringlist sl;
		
		sl << "myParam=[value]";
		
		return sl.toString( '\n' );
	}

	return "";
}

// timer events come here
void TestLeitch::timerCallback( int id )
{
	switch( id )
	{
	case TIMER_SETUP:
		timerStop(id);
		break;

	default:	// Unhandled timer event
		timerStop(id);
		break;
	}
}


///////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////// Callbacks above - Methods below ///////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////


